#include <stdio.h>
#include <malloc.h>

int bgmtable[][3]={
	//t@Cʒu@kTCY@𓀃TCY
	{0x00054, 0x07d32, 0x18ddb},
	{0x07d32, 0x0d22f, 0x1611b},
	{0x0d22f, 0x1320b, 0x18340},
	{0x1320b, 0x1c647, 0x23be9},
	{0x1c647, 0x23a53, 0x15f51},

	{0x23a53, 0x2b866, 0x1b62c},
};

char bgmfile[][50]={
	"01 tHXXgx[.mid",
	"02 v[YV@.mid",
	"03 zs.mid",
	"04 fBUXgXWF~j.mid",
	"05 ؂̌z@g̒.mid",

	"06 VA[~[.mid",
};
int decode(char *, int, char *, int);
int bit(char **, int *, int);

int main(int argc, char* argv[]){

	int i;
	char *enc, *dec;
	FILE *datf,*bgmf;

	datf=fopen("MUSIC.DAT","rb");
	if(datf==NULL){
		printf("MUSIC.DAT not found.\n");
		return 0;
	}

	enc = (char *)malloc(0x4ADE20 * 2);
	dec = (char *)malloc(0x4ADE20 * 2);
	if(enc == NULL || dec == NULL){
		printf("Can't allocate memory\n");
		return 0;
	}

	for(i=0; i<6; i++){
		printf("Create %s ... \n",bgmfile[i]);

		bgmf = fopen(bgmfile[i],"wb");
		if(bgmf == NULL){
			printf("Can't open file %s\n", bgmfile[i]);
			break;
		}
		fseek(datf,bgmtable[i][0],SEEK_SET);
		fread(enc,1,bgmtable[i][1],datf);

		decode(enc, bgmtable[i][1], dec, bgmtable[i][2]);

		if(fwrite(dec,1,bgmtable[i][2],bgmf) == 0){
			printf("Can't write file %s\n", bgmfile[i]);
			fclose(bgmf);
			break;
		}
		fclose(bgmf);
	}
	free(enc);
	free(dec);
	fclose(datf);
	
	return 0;
}

//ky@
int decode(char *p1, int d1, char *p2, int d2)
{
	char *dic_p = p2 + 0x630041;
	char *e_p   = p2 + d2;
	char buf;

	int adr;
	int cnt = 1;
	int chk = 0x100;
	int i,j;

	while(p2 < e_p){

		if( bit(&p1, &chk, 1) ){

			buf = bit(&p1, &chk, 8);

			*p2++ = buf;
			*(dic_p + cnt) = buf;
			cnt = (cnt + 1) & 0x1fff;
		}
		else {

			adr = bit(&p1, &chk, 13);
			j   = bit(&p1, &chk, 4);

			for(i=0; i<=j+2; i++){
				buf = *(dic_p + adr);
				adr = (adr + 1) & 0x1fff;

				*p2++ = buf;
				*(dic_p + cnt) = buf;
				cnt = (cnt + 1) & 0x1fff;
			}
		}
	}
	return 0;
}

int bit(char **p1, int *chk, int turn)
{
	int i, result=0;

	for(i=0; i<turn; i++){
		result <<=1;

		*chk >>= 1;
		if(*chk == 0x00){
			*chk = 0x80;
			*p1 = *p1 + 1;
		}

		if(**p1 & *chk)
			result |= 0x01;
	}

	return result;
}
